<?PHP
/* $Id: index.php,v 1.1.2.1 2005/01/28 09:36:47 bzizou Exp $

VNC gateway

This script is part of the SLIS Project initiated by the CARMI-Internet
(Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet
(Acadmie de Grenoble - France 38).

This script have been writen by Bruno Bzeznik - copyright (C) 2001
Ce script  t crit par Bruno Bzeznik - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire.
Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License
along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail
to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  <slis@ac-grenoble.fr>
FC
*/

// loading libs and init
require("../inc/html.inc.php");
require("../inc/pgsql.inc.php");
require("../inc/lib.inc.php");
require("../inc/dns.inc.php");

$cnx = dbconnect();

// Recherche de l'adresseIP locale du slis
$iplocale = getIPlocal();
$infodomaine = getDomaine();

// $local est le domaine intranet.local par dfault   tude du non de la zone ventuellement du nouveau nom de la zone
if ($nz != '' and $nz != ".local") $local = $nz; 
else $local = setzone("intranet.local", $infodomaine[hostname], $cnx);

echo startHTML("$lang_adv_DNS");

$ok = false;
$ok2 = false;  // Appuie sur Annuler ou sur Modifier
$oksetip= true;   //
#$tmp2 = loadmachine($oldip, $oldnom, setIdZone($cnx, $zone), $cnx); 
// Recherche si mise  jour ou pas
if ($mod and $modifier)
{
#  $tmpzone = setIdZone($cnx, $zone);
  $tmp2 = loadmachine($oldip, $oldnom, $zone, $cnx);
  if ($tmp2[tomodif] == 't')
  {
    if (strcmp($nom, $tmp2[nnom]) == 0) $a1=false; else $a1=true;
    if (strcmp($ip, $tmp2[nip]) == 0) $a2=false; else $a2=true;
    if (strcmp($commentaire, $tmp2[ncommentaire]) == 0) $a3=false; else $a3=true; 
  }
  else
  {
    if (strcmp($nom, $tmp2[nom]) == 0) $a1=false; else $a1=true; 
    if (strcmp($ip, $tmp2[ip]) == 0) $a2=false; else $a2=true; 
    if (strcmp($commentaire, $tmp2[commentaire]) == 0) $a3=false; else $a3=true; 
  }
  $ok2 = ($a1 || $a2 || $a3);  
}
if ($modifier || $ajout) $oksetip = setIP($ip);
// test que l'ip ne se termine pas par un point
if (substr($ip, -1) == ".") $oksetip = false;
if (!$oksetip) $text .= "<font color=\"red\">".$lang_adv_dnsmauvaiseip."</font><p>";
// Recherche d'unicit de nom sur la zone et l'ip
if (($ok2) || ($creation != "")) 
{
  $tmpzone = $zone;
  if ($creation != "") $tmpzone = setIdZone($cnx, $zone);
  if ($tmp2[tomodif] == 't')
     $tmp = setIPnomZone($cnx, $ip, $nom, $commentaire, $tmpzone, $lang_adv_dnsipnomzoneexiste, $lang_adv_dnsnomzoneexiste, "");
  else $tmp = setIPnomZone($cnx, $ip, $nom, $commentaire, $tmpzone, $lang_adv_dnsipnomzoneexiste, $lang_adv_dnsnomzoneexiste, "f");
  $ok = $tmp[ok];
}
if (!$ok) $text .= "<font color=\"red\">".$tmp[txt]."</font><p>";
// Suppression d'une machine
if ($sup) deleteDNS($ip, $nom, $zone, $cnx);
// Modification d'une machine
if ($ok and $ok2 and $oksetip) modifdns($oldip, $oldnom, $cnx, $ip, $nom, $alias, $commentaire, $zone);

// Cration d'une entre DNS
if ($ajout)
{
  // Cration de l'entre DNS
  if ($nom <> "" and $ip <> "")
  {
    // Suppression des espaces en dbut et fin de chane
    $nom = trim($nom);
    $alias = trim($alias);
    $ip = trim($ip);
    // Recherche des caractres interdits dans le nom de la machine et son alias
    if (ereg("[&#;:?!@%$<>*+/,.'` ]", $nom))
     {
     	$text .= "<font color=\"red\">$lang_adv_dnscaracinterdits <i>&#<>;:?!@%$*+/.,'`  <espace></i></font><p>";
        $ok = false;
     }
     
     
     //   *********************************************************************
     //  these comments authorize nonprivate IP addresses with being added in the local zone
     //   *********************************************************************
     
    // $privee = setPrivateIp($ip); 
    // Validation de l'adresse IP choisie
    // if (
    //     ($zone != $infodomaine[hostname]) and 
    //    (! $privee) 
    //   )
    //{
    //   $text .= "<font color=\"red\">$lang_adv_dnserreurip.</font><p>";
    //   $ok = false;
   // }
   
   //   *********************************************************************
   //  end of the comments
   //   *********************************************************************
   
    // Recherche d'absence de lettre dans l'adresse ip
    if (ereg("[a-zA-Z]{1,3}", $ip)) {$text .= "<font color=\"red\">".$lang_adv_dnserreuriplettre."</font><p>"; $ok=0;}
    if ( ($zone != $infodomaine[hostname]) and
         ereg("[a-zA-Z]{1,3}", $ip) )     // il  n'y a pas de lettres saisies dans l'adresse ip
    {
       if ($ok) $text .= "<font color=\"red\">$lang_adv_dnserreurip $iplocale.</font><p>";
       $ok = false;
    }
    // Cration de l'entre dans le DNS
    if ($ok and $oksetip)
    {  
      // Recherche du commentaire de la machine
      if ($autre) $type = $autre; else $type=$typemachine;
      if (createDNS($ip, $nom, $alias, $commentaire, $type, $cnx, $zone) == false)
          $text .= "<font color=\"red\">$lang_adv_dnserreurcreation</font><p>";
    }
  }
  else $text .= "$lang_adv_dnsipnommanque<p>";
}

switch ($action)
{
 case "ajouter":
   {
     // Page de cration d'une nouvelle entre DNS
     $text .= "<TABLE ALIGN=CENTER>\n";
     $text .= "<tr><td>$lang_adv_dnsintro$infodomaine[hostname].\n";
     $text .= "<hr width=100%>".setTabAddDesktop($cnx, $lang_adv_dnsip, $lang_adv_dnsnom, $lang_adv_dnscommentaire, $lang_adv_dnsbouttondeclarer, $lang_adv_dnsajoutmachine, $lang_adv_dnszoneconcernee, $local);
     break;
   }
 case "modifier":
   {
     // Modification d'une entre DNS
     $text .= "<TABLE ALIGN=CENTER>\n";
     $text .= "<hr width=100%>".setTabUpdateDesktop($zone, $ip, $nom, $cnx, $lang_adv_dnsip, $lang_adv_dnsnom, $lang_adv_dnscommentaire, $lang_adv_dnstabmodifier, $lang_adv_dnszoneconcernee, $lang_adv_dnsinfomodif, $lang_adv_dnsannuler, $lang_adv_dnsmachineexistepasdomaine);
     // Modification d'une entre DNS
     break;
   }
 default:
   {
     break;
   }
}

$text .= "<hr width=100%>\n";
$text .= "<center><b>$lang_adv_dnsliste $local</b>&nbsp;<a href=\"zone.php\"><img title=\"$lang_adv_dnsnomzone\" alt=\"$lang_adv_dnsnomzone\" src=\"../images/reseau.gif\" border=0></a>&nbsp;";
$text .= "</center><p>\n";
$text .= getList("tableau", $cnx, $local, $lang_adv_dnsnom, $lang_adv_dnstabsupprimer, $lang_adv_dnstabmodifier, $lang_adv_dnsinfomodifiees);
$text .= "<p><hr width=100%>\n";
$text .= "<center><b>$lang_adv_dnsliste $infodomaine[hostname]</b></center><p>\n";
$text .= getList("tableau", $cnx, $infodomaine[hostname], $lang_adv_dnsnom, $lang_adv_dnstabsupprimer, $lang_adv_dnstabmodifier, $lang_adv_dnsinfomodifiees);
$text .= "<p><hr width=100%>\n";
$text .= "<center><font color=\"red\">$lang_adv_dnsinfosup</font>&nbsp;<font color=\"blue\">$lang_adv_dnsinfonvalid</font>&nbsp;<font color=\"green\">$lang_adv_dnsinfovalid</font>";
// Affichage ou non de la mise en garde de mise  jour
$query = "select * from DNSmachine where tomodif='t' or tovalid='t' or todelete='t'";
if ($result = pg_exec($cnx, $query))
{
  $nb = pg_numrows($result);
  $query = "select * from DNSzone where nnomzone <> ''";
  if ($result = pg_exec($cnx, $query))
    if ((pg_numrows($result) > 0) or ($nb > 0))
      $text .= "<p>$lang_adv_valider</center><p>";
}
$text .= "</td></tr></table>\n";

$val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,"$lang_adv_DNS",$titre_color);
$val = center($val);
$val = saut(2)."$val";
print "$val\n";

// The end
print endHTML();

pg_close($cnx);
?>
